/*
 *  $Id: start.c,v 1.3 1993/11/12 12:08:37 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Start - 
@*/
MPI_Start( handle )
MPI_Comm_request handle;
{
    int is_available;

    if (handle->type == MPIR_SEND)
    {
#ifdef WHEN_WE_DO_THIS
	if (MPIR_IS_CONTIGDATAELEMENT(handle->shandle.datatype)) {
	    handle->shandle.bufadd = .....;
	    ...;
	    }
#endif
	/* device will post the send */
	MPID_post_send( &(handle->shandle) );
    }
    else if (handle->type == MPIR_RECV)
    {
#ifdef WHEN_WE_DO_THIS
	if (MPIR_IS_CONTIGDATAELEMENT(handle->rhandle.datatype)) {
	    handle->rhandle.bufadd = ... ;
	    }
#endif
        /* device will handle queueing of MPIR recv handle in posted-recv queue         */
	MPID_post_recv( &(handle->rhandle), &(is_available) );
    }
    else
	MPIR_error("bad handle type in MPI_START");
}


