/*
 *  $Id: map_cart.c,v 1.3 1993/11/12 12:35:46 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Map_cart - map process to cart topology information 

@*/
int MPI_Map_cart ( comm_old, ndims, dims, periods, newrank )
MPI_Comm comm_old;
int              ndims;
int             *dims;
int             *periods;
int             *newrank;
{
  int i;
  int nranks = 1;
  int rank;

  /* Check for valid arguments */
  if ( (comm_old == (MPI_Comm)0 ) ||
       (ndims < 1) ||
       (newrank == (int *)0) ||
       (dims == (int *)0) )
    return (MPI_SUCCESS);
  
  /* Determine number of processes needed for topology */
  for ( i=0; i<ndims; i++ )
    nranks *= dims[i];

  /* Am I in this range? */
  MPI_Comm_rank ( comm_old, &rank );
  if ( rank < nranks )
    (*newrank) = rank;
  else
    (*newrank) = MPI_UNDEFINED;

  return (MPI_SUCCESS);
}
